package kr.pe.theeye.camera;

import java.io.File;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.media.ExifInterface;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Toast;

public class MainActivity extends Activity
{
	public static final int REQUEST_CAMERA = 9000;
	private ImageView imageView;
	private Uri imageUri;
	
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        Button button = (Button) findViewById(R.id.capture);
        imageView = (ImageView) findViewById(R.id.image);
        
        button.setOnClickListener(new OnClickListener()
		{
			@Override
			public void onClick(View view)
			{
				// ӽ÷   
				File photo = new File(Environment.getExternalStorageDirectory(),  ".camera.jpg");
				imageUri = Uri.fromFile(photo);

				// ī޶ ȣմϴ.
				Intent i = new Intent("android.media.action.IMAGE_CAPTURE");
				i.putExtra(MediaStore.EXTRA_OUTPUT, imageUri);
				MainActivity.this.startActivityForResult(i,REQUEST_CAMERA);
			}
		});
    }

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data)
	{
		if(requestCode == REQUEST_CAMERA && resultCode == RESULT_OK)
		{
			try
			{
				// Ʈ ̹ ´
				String imagePath = imageUri.getPath();
				Bitmap image = BitmapFactory.decodeFile(imagePath);
				
				// ̹ Ȳ ° ȸŲ
				ExifInterface exif = new ExifInterface(imagePath);
				int exifOrientation = exif.getAttributeInt(ExifInterface.TAG_ORIENTATION, ExifInterface.ORIENTATION_NORMAL);
				int exifDegree = exifOrientationToDegrees(exifOrientation);
				image = rotate(image, exifDegree);
				
				// ȯ ̹ 
				imageView.setImageBitmap(image);
			}
			catch(Exception e)
			{
				Toast.makeText(this, "߻: " + e.getLocalizedMessage(), Toast.LENGTH_LONG).show();
			}
		}
	}
	
	/**
	 * EXIF ȸ ȯϴ ޼
	 * 
	 * @param exifOrientation EXIF ȸ
	 * @return  
	 */
	public int exifOrientationToDegrees(int exifOrientation)
	{
		if(exifOrientation == ExifInterface.ORIENTATION_ROTATE_90)
		{
			return 90;
		}
		else if(exifOrientation == ExifInterface.ORIENTATION_ROTATE_180)
		{
			return 180;
		}
		else if(exifOrientation == ExifInterface.ORIENTATION_ROTATE_270)
		{
			return 270;
		}
		return 0;
	}
	
	/**
	 * ̹ ȸŵϴ.
	 * 
	 * @param bitmap Ʈ ̹
	 * @param degrees ȸ 
	 * @return ȸ ̹
	 */
	public Bitmap rotate(Bitmap bitmap, int degrees)
	{
		if(degrees != 0 && bitmap != null)
		{
			Matrix m = new Matrix();
			m.setRotate(degrees, (float) bitmap.getWidth() / 2, (float) bitmap.getHeight() / 2);
			
			try
			{
				Bitmap converted = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(), bitmap.getHeight(), m, true);
				if(bitmap != converted)
				{
					bitmap.recycle();
					bitmap = converted;
				}
			}
			catch(OutOfMemoryError ex)
			{
				// ޸𸮰 Ͽ ȸ Ű   ׳  ȯմϴ.
			}
		}
		return bitmap;
	}
}